// C Source File
// Created 04.06.04; 17:12:58

#define USE_TI89              // Compile for TI-89

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

// Main Function
void _main(void)
{
  //Flieger malen
  unsigned short int sprit[] = {0x8060,0xC0E0,0xFFFE,0xFFFD,0x7FFF,0x0FFE,0x0380,0x0300};
  //Umrisse fr Crash-Check
  char koor[] = {0,0, 1,1, 2,2, 3,2, 4,2, 5,2, 6,2, 7,2, 8,1, 9,0, 10,0, 11,2, 12,2, 13,2, 14,2, 15,3,
  0,3, 1,4, 2,4, 3,4, 4,5, 5,5, 6,7, 7,7, 8,6, 9,5, 10,5, 11,5, 12,5, 13,5, 14,5, 15,4};
  //Zhler
  char zaehler = 0;
  int i;
  unsigned long int zaehler2 = 0;
  static unsigned long int rekord = 0;
  int hoehe = 54;  //Abstand des Fliegers vom Himmel
  int entf1 = 162, hindhoehe1, entf2 = 252, hindhoehe2; //Position der Hindernisse
  char buffer[11], bufferr[19]; //Buffer zum Schreiben von aktueller Zeit und Rekord
  char untbr; //Flag zum Neustart nach Crash
  float speed = 2; //vertikale Geschwindigkeit des Fliegers
  char strecke[200], links, rechts, hinderh1 = 0, hinderh2 = 0; //Streckenverlauf
  while(TRUE) // bei Absturz immer neu beginnen
  {
	  ClrScr(); // Bildschirm leeren
	  untbr = FALSE; // kein Neustart (mehr)
		for(i = 0;i < 160;i++) // Strecke gerade bei 20 am Anfang
		{
			strecke[i] = 20;
		}
		links = 20; // Strecke bei 20 beginnen
		rechts = rand() / (RAND_MAX / 20) + 1; // Richtung der Strecke festlegen
		for(i = 160;i < 200;i++)
		{
			strecke[i] = links + ((rechts - links) * (i - 159)) / 40;
		}
		for(i = 0;i <= 20;i++) // Linie oben malen
		{
			DrawLine(0,i,160,i,A_NORMAL);
		}
		DrawLine(0,92,160,92,A_NORMAL);
		OSFreeTimer(USER_TIMER);	  //Timer initialisieren
		OSRegisterTimer(USER_TIMER,1);	  //Timer initialisieren
		randomize();  //Zufallsgenerator initialisieren
		FontSetSys(F_4x6); //kleine Schrift einstellen
		Sprite16(20,hoehe,8,sprit,LCD_MEM,SPRT_OR); //Flieger zeichnen
		hindhoehe1 = rand() / (RAND_MAX / 43) + 2; // Hindernishhe berechnen
		hindhoehe2 = rand() / (RAND_MAX / 43) + 2; // Hindernishhe berechnen
		while(TRUE) // Einzelne Zeichenschritte immer neu beginnen
		{
	  	sprintf(bufferr,"REKORD: %lu",rekord); // Rekord in bufferr schreiben
		  DrawStr(70,94,bufferr,A_REPLACE); // bufferr einzeichnen
  	  while(!OSTimerExpired(USER_TIMER)); // warten, bis Timer ausschlgt
  		if(_keytest(RR_DOWN)) // wenn "unten" gedrckt ist
	 		{
	  		if(speed != 2)   speed += 0.2; // vert. Geschwindigkeit erhhen
  		}
	 		else
	  	{
  			if(speed != -2)   speed -= 0.2; // vert. Geschwindigkeit senken
	 		}
		 	if(_keytest(RR_ESC)) // bei ESC
  		{
	  		return; //Programm beenden	
			}
			if(_keytest(RR_DOT)) // Pause, wenn Punkt gedrckt
			{
				ngetchx();
				ngetchx();
			}
			if(entf1 >= 0)   hinderh1 = strecke[entf1];
			if(entf2 >= 0)   hinderh2 = strecke[entf2];
			if(entf1 < 157)   DrawLine(entf1 + 3,hindhoehe1 + hinderh1,entf1 + 3,hindhoehe1 + hinderh1 + 25,A_REVERSE); //letzte Hindernislinie lschen
			if(entf2 < 157)   DrawLine(entf2 + 3,hindhoehe2 + hinderh2,entf2 + 3,hindhoehe2 + hinderh2 + 25,A_REVERSE); //letzte Hindernislinie lschen
		  entf1--; // Hindernis kommt nher
		  entf2--; // Hindernis kommt nher
 			if(entf1 < -4) //wenn Hindernis links verschwunden ist
		  {
 		 		entf1 = 177; //Hindernis ganz rechts
				hindhoehe1 = rand() / (RAND_MAX / 43) + 2; //neue Hindernishhe berechnen	
	 		}
 			if(entf2 < -4) //wenn Hindernis links verschwunden ist
		  {
 		 		entf2 = 177; //Hindernis ganz rechts
				hindhoehe2 = rand() / (RAND_MAX / 43) + 2; //neue Hindernishhe berechnen	
	 		}
			for(i = 0;i < 200;i++)
			{
				if(strecke[i] < strecke[i + 1])
				{
					DrawPix(i,strecke[i + 1],A_NORMAL);
					DrawPix(i,72 + strecke[i],A_REVERSE);
				}
				else if(strecke[i] > strecke[i + 1])
				{
					DrawPix(i,strecke[i],A_REVERSE);
					DrawPix(i,72 + strecke[i + 1],A_NORMAL);
				}
				strecke[i] = strecke[i + 1];
			}
			if(entf1 >= 0 && entf1 < 160)   DrawLine(entf1,hindhoehe1 + strecke[entf1],entf1,hindhoehe1 + strecke[entf1] + 25,A_NORMAL); //neue Hindernislinie zeichnen
			if(entf2 >= 0 && entf2 < 160)   DrawLine(entf2,hindhoehe2 + strecke[entf2],entf2,hindhoehe2 + strecke[entf2] + 25,A_NORMAL); //neue Hindernislinie zeichnen
			Sprite16(20,hoehe,8,sprit,LCD_MEM,SPRT_XOR); //Flieger lschen
			hoehe += speed; //neuen Abstand vom Himmel berechnen (+ vert. Geschwindigkeit)
			for(i = 0;i < 64;i += 2) //Crashtest
			{
				if(GetPix(20 + (int) koor[i],hoehe + (int) koor[i + 1])) //wenn Umrisspixel schon besetzt ist -> Crash
				{
					untbr = TRUE; //Unterbrechungsflag setzen
					zaehler = 0; //Zhler auf 0 setzen
					zaehler2 = 0;
					hoehe = 54;
					entf1 = 162;
					entf2 = 252;
					speed = 2;
					break;
				}
			}
			if(untbr)   break; //wenn Flag gesetzt, wieder von vorne anfangen
			Sprite16(20,(int)hoehe,8,sprit,LCD_MEM,SPRT_OR); //neuen Flieger zeichnen
			zaehler++; //Zhler erhhen
			if(zaehler == 20) // Wenn eine Sekunde vorbei
			{
				zaehler = 0; //Zhler auf 0
				zaehler2++; //Groer Zhler erhhen
			  sprintf(buffer,"%lu",zaehler2); //Groen Zhler in Buffer schreiben
			  DrawStr(5,94,buffer,A_REPLACE); // Buffer zeichnen
			  if(zaehler2 > rekord) //Wenn Rekord berboten
			  {
			  	rekord = zaehler2; //neuer Rekord
			  	sprintf(bufferr,"REKORD: %lu",rekord); //neuen Rekord zeichnen
				  DrawStr(70,94,bufferr,A_REPLACE);
			  }
			  if(zaehler2 % 2 == 0) // alle 2 Sek neuen Streckenverlauf berechnen
			  {
					links = rechts;
					rechts = rand() / (RAND_MAX / 20) + 1;
					for(i = 160;i < 200;i++)
					{
						strecke[i] = links + ((rechts - links) * (i - 159)) / 40;
					}
			  }
			}
		}
	}
}
